diff --git a/ui/app/controllers/CControllerUsergroupUpdate.php b/ui/app/controllers/CControllerUsergroupUpdate.php
index 755afc8c7ef..7c399cc6922 100644
--- a/ui/app/controllers/CControllerUsergroupUpdate.php
+++ b/ui/app/controllers/CControllerUsergroupUpdate.php
@@ -23,20 +23,21 @@ class CControllerUsergroupUpdate extends CController {
 
 	protected function checkInput() {
 		$fields = [
-			'usrgrpid'        => 'required|db usrgrp.usrgrpid',
-			'name'            => 'not_empty|db usrgrp.name',
-			'userids'         => 'array_db users.userid',
-			'gui_access'      => 'db usrgrp.gui_access|in '.implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_INTERNAL, GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_DISABLED]),
-			'users_status'    => 'db usrgrp.users_status|in '.GROUP_STATUS_ENABLED.','.GROUP_STATUS_DISABLED,
-			'debug_mode'      => 'db usrgrp.debug_mode|in '.GROUP_DEBUG_MODE_ENABLED.','.GROUP_DEBUG_MODE_DISABLED,
+			'usrgrpid' =>			'required|db usrgrp.usrgrpid',
+			'name' =>				'not_empty|db usrgrp.name',
+			'userids' =>			'array_db users.userid',
+			'gui_access' =>			'db usrgrp.gui_access|in '.implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_INTERNAL, GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_DISABLED]),
+			'userdirectoryid' =>	'db usrgrp.userdirectoryid',
+			'users_status' =>		'db usrgrp.users_status|in '.GROUP_STATUS_ENABLED.','.GROUP_STATUS_DISABLED,
+			'debug_mode' =>			'db usrgrp.debug_mode|in '.GROUP_DEBUG_MODE_ENABLED.','.GROUP_DEBUG_MODE_DISABLED,
 
-			'group_rights'    => 'array',
-			'tag_filters'     => 'array',
+			'group_rights' =>		'array',
+			'tag_filters' =>		'array',
 
-			'new_group_right' => 'array',
-			'new_tag_filter'  => 'array',
+			'new_group_right' =>	'array',
+			'new_tag_filter' =>		'array',
 
-			'form_refresh'    => 'int32'
+			'form_refresh' =>		'int32'
 		];
 
 		$ret = $this->validateInput($fields);
@@ -74,7 +75,9 @@ class CControllerUsergroupUpdate extends CController {
 			'rights' => []
 		];
 
-		$this->getInputs($user_group, ['usrgrpid', 'name', 'users_status', 'gui_access', 'debug_mode']);
+		$this->getInputs($user_group, ['usrgrpid', 'name', 'users_status', 'gui_access', 'debug_mode',
+			'userdirectoryid'
+		]);
 
 		$group_rights = applyHostGroupRights($this->getInput('group_rights', []));
 
diff --git a/ui/app/views/administration.authentication.edit.php b/ui/app/views/administration.authentication.edit.php
index 1f6d1385d7a..1e0413cf939 100644
--- a/ui/app/views/administration.authentication.edit.php
+++ b/ui/app/views/administration.authentication.edit.php
@@ -21,6 +21,7 @@
 
 /**
  * @var CView $this
+ * @var array $data
  */
 
 $this->includeJsFile('administration.authentication.edit.js.php');
@@ -134,24 +135,6 @@ $http_tab = (new CFormList('list_http'))
 			->setUncheckedValue(ZBX_AUTH_CASE_INSENSITIVE)
 	);
 
-// LDAP configuration fields.
-if ($data['change_bind_password']) {
-	$password_box = [
-		new CVar('change_bind_password', 1),
-		(new CPassBox('ldap_bind_password', $data['ldap_bind_password']))
-			->setEnabled($data['ldap_enabled'])
-			->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)
-	];
-}
-else {
-	$password_box = [
-		new CVar('action_passw_change', $data['action_passw_change']),
-		(new CButton('change_bind_password', _('Change password')))
-			->setEnabled($data['ldap_enabled'])
-			->addClass(ZBX_STYLE_BTN_GREY)
-	];
-}
-
 $ldap_tab = (new CFormList('list_ldap'))
 	->addRow(new CLabel(_('Enable LDAP authentication'), 'ldap_configured'),
 		$data['ldap_error']
@@ -160,54 +143,38 @@ $ldap_tab = (new CFormList('list_ldap'))
 				->setChecked($data['ldap_configured'] == ZBX_AUTH_LDAP_ENABLED)
 				->setUncheckedValue(ZBX_AUTH_LDAP_DISABLED)
 	)
-	->addRow((new CLabel(_('LDAP host'), 'ldap_host'))->setAsteriskMark(),
-		(new CTextBox('ldap_host', $data['ldap_host']))
-			->setEnabled($data['ldap_enabled'])
-			->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
-			->setAriaRequired()
-	)
-	->addRow((new CLabel(_('Port'), 'ldap_port'))->setAsteriskMark(),
-		(new CNumericBox('ldap_port', $data['ldap_port'], 5))
-			->setEnabled($data['ldap_enabled'])
-			->setWidth(ZBX_TEXTAREA_NUMERIC_STANDARD_WIDTH)
-			->setAriaRequired()
-	)
-	->addRow((new CLabel(_('Base DN'), 'ldap_base_dn'))->setAsteriskMark(),
-		(new CTextBox('ldap_base_dn', $data['ldap_base_dn']))
-			->setEnabled($data['ldap_enabled'])
-			->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
-			->setAriaRequired()
-	)
-	->addRow((new CLabel(_('Search attribute'), 'ldap_search_attribute'))->setAsteriskMark(),
-		(new CTextBox('ldap_search_attribute', $data['ldap_search_attribute']))
-			->setEnabled($data['ldap_enabled'])
-			->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
-			->setAriaRequired()
-	)
-	->addRow(new CLabel(_('Bind DN'), 'ldap_bind_dn'),
-		(new CTextBox('ldap_bind_dn', $data['ldap_bind_dn']))
-			->setEnabled($data['ldap_enabled'])
-			->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
+	->addRow((new CLabel(_('Servers')))->setAsteriskMark(),
+		(new CDiv(
+			(new CTable())
+				->setId('ldap-servers')
+				->setHeader(
+					(new CRowHeader([
+						(new CColHeader(_('Name')))->addStyle('width: 40%'),
+						(new CColHeader(_('Host')))->addStyle('width: 40%'),
+						(new CColHeader(_('User groups')))->addClass(ZBX_STYLE_NOWRAP),
+						_('Default'),
+						''
+					]))->addClass(ZBX_STYLE_GREY)
+				)
+				->addItem(
+					(new CTag('tfoot', true))
+						->addItem(
+							(new CCol(
+								(new CSimpleButton(_('Add')))
+									->addClass(ZBX_STYLE_BTN_LINK)
+									->addClass('js-add')
+							))->setColSpan(5)
+						)
+				)
+				->addStyle('width: 100%;')
+		))
+			->addClass(ZBX_STYLE_TABLE_FORMS_SEPARATOR)
+			->addStyle('min-width: '.ZBX_TEXTAREA_BIG_WIDTH.'px;')
 	)
 	->addRow(new CLabel(_('Case-sensitive login'), 'ldap_case_sensitive'),
 		(new CCheckBox('ldap_case_sensitive', ZBX_AUTH_CASE_SENSITIVE))
 			->setChecked($data['ldap_case_sensitive'] == ZBX_AUTH_CASE_SENSITIVE)
-			->setEnabled($data['ldap_configured'] == ZBX_AUTH_LDAP_ENABLED)
 			->setUncheckedValue(ZBX_AUTH_CASE_INSENSITIVE)
-	)
-	->addRow(new CLabel(_('Bind password'), 'ldap_bind_password'), $password_box)
-	->addRow(_('Test authentication'), ' ['._('must be a valid LDAP user').']')
-	->addRow((new CLabel(_('Login'), 'ldap_test_user'))->setAsteriskMark(),
-		(new CTextBox('ldap_test_user', $data['ldap_test_user']))
-			->setEnabled($data['ldap_enabled'])
-			->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
-			->setAriaRequired()
-	)
-	->addRow((new CLabel(_('User password'), 'ldap_test_password'))->setAsteriskMark(),
-		(new CPassBox('ldap_test_password', $data['ldap_test_password']))
-			->setEnabled($data['ldap_enabled'])
-			->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)
-			->setAriaRequired()
 	);
 
 // SAML authentication fields.
@@ -323,9 +290,8 @@ $saml_tab = (new CFormList('list_saml'))
 	->setTitle(_('Authentication'))
 	->addItem((new CForm())
 		->addVar('action', $data['action_submit'])
-		->addVar('db_authentication_type', $data['db_authentication_type'])
+		->addVar('ldap_removed_userdirectoryids', $data['ldap_removed_userdirectoryids'])
 		->setId('authentication-form')
-		->setName('form_auth')
 		->setAttribute('aria-labeledby', ZBX_STYLE_PAGE_TITLE)
 		->disablePasswordAutofill()
 		->addItem((new CTabView())
@@ -335,12 +301,18 @@ $saml_tab = (new CFormList('list_saml'))
 			->addTab('ldap', _('LDAP settings'), $ldap_tab, TAB_INDICATOR_AUTH_LDAP)
 			->addTab('saml', _('SAML settings'), $saml_tab, TAB_INDICATOR_AUTH_SAML)
 			->setFooter(makeFormFooter(
-				(new CSubmit('update', _('Update'))),
-				[(new CSubmitButton(_('Test'), 'ldap_test', 1))
-					->addStyle(($data['form_refresh'] && CCookieHelper::get('tab') == 2) ? '' : 'display: none')
-					->setEnabled($data['ldap_enabled'])
-				]
+				(new CSubmit('update', _('Update')))
 			))
 			->onTabChange('jQuery("[name=ldap_test]")[(ui.newTab.index() == 2) ? "show" : "hide"]()')
 	))
 	->show();
+
+(new CScriptTag(
+	'view.init('. json_encode([
+		'ldap_servers' => $data['ldap_servers'],
+		'ldap_default_row_index' => $data['ldap_default_row_index'],
+		'db_authentication_type' => $data['db_authentication_type']
+	], JSON_FORCE_OBJECT).');'
+))
+	->setOnDocumentReady()
+	->show();
diff --git a/ui/app/views/administration.usergroup.edit.php b/ui/app/views/administration.usergroup.edit.php
index 1685674ff97..f0a946db958 100644
--- a/ui/app/views/administration.usergroup.edit.php
+++ b/ui/app/views/administration.usergroup.edit.php
@@ -74,8 +74,16 @@ if ($data['can_update_group']) {
 			GROUP_GUI_ACCESS_DISABLED => user_auth_type2str(GROUP_GUI_ACCESS_DISABLED)
 		]));
 
+	$userdirectory = (new CSelect('userdirectoryid'))
+		->setValue($data['userdirectoryid'])
+		->setFocusableElementId('userdirectoryid')
+		->addOption((new CSelectOption(0, _('Default')))->addClass(ZBX_STYLE_DEFAULT_OPTION))
+		->addOptions(CSelect::createOptionsFromArray($data['userdirectories']))
+		->setAdaptiveWidth(ZBX_TEXTAREA_STANDARD_WIDTH);
+
 	$form_list
 		->addRow((new CLabel(_('Frontend access'), $select_gui_access->getFocusableElementId())), $select_gui_access)
+		->addRow((new CLabel(_('LDAP Server'), $userdirectory->getFocusableElementId())), $userdirectory)
 		->addRow(_('Enabled'), (new CCheckBox('users_status', GROUP_STATUS_ENABLED))
 			->setUncheckedValue(GROUP_STATUS_DISABLED)
 			->setChecked($data['users_status'] == GROUP_STATUS_ENABLED)
diff --git a/ui/app/views/js/administration.authentication.edit.js.php b/ui/app/views/js/administration.authentication.edit.js.php
index 1baac8907f4..ba11431449c 100644
--- a/ui/app/views/js/administration.authentication.edit.js.php
+++ b/ui/app/views/js/administration.authentication.edit.js.php
@@ -24,53 +24,227 @@
  */
 ?>
 
-<script type="text/javascript">
-	jQuery(function($) {
-		var $form = $('[name=form_auth]'),
-			warn = true;
-
-		$form.submit(function() {
-			var proceed = !warn
-				|| $('[name=authentication_type]:checked').val() == $('[name=db_authentication_type]').val()
-				|| confirm(<?= json_encode(
-					_('Switching authentication method will reset all except this session! Continue?')
-				) ?>);
-			warn = true;
-
-			$form.trimValues(['#saml_idp_entityid', '#saml_sso_url', '#saml_slo_url', '#saml_username_attribute',
+<script>
+	const view = new class {
+
+		constructor() {
+			this.form = null;
+			this.db_authentication_type = null;
+		}
+
+		init({ldap_servers, ldap_default_row_index, db_authentication_type}) {
+			this.form = document.getElementById('authentication-form');
+			this.db_authentication_type = db_authentication_type;
+
+			this._addEventListeners();
+			this._addLdapServers(ldap_servers, ldap_default_row_index);
+		}
+
+		_addEventListeners() {
+			document
+				.getElementById('ldap-servers')
+				.addEventListener('click', (e) => {
+					if (e.target.classList.contains('js-add')) {
+						this.editLdapServer();
+					}
+					else if (e.target.classList.contains('js-edit')) {
+						this.editLdapServer(e.target.closest('tr'));
+					}
+					else if (e.target.classList.contains('js-remove')) {
+						const table = e.target.closest('table');
+						const userdirectoryid_input = e.target.closest('tr')
+							.querySelector('input[name$="[userdirectoryid]"]');
+
+						if (userdirectoryid_input !== null) {
+							const input = document.createElement('input');
+							input.type = 'hidden';
+							input.name = 'ldap_removed_userdirectoryids[]';
+							input.value = userdirectoryid_input.value;
+							this.form.appendChild(input);
+						}
+
+						e.target.closest('tr').remove();
+
+						if (table.querySelector('input[name="ldap_default_row_index"]:checked') === null) {
+							const default_ldap = table.querySelector('input[name="ldap_default_row_index"]');
+
+							if (default_ldap !== null) {
+								default_ldap.checked = true;
+							}
+						}
+					}
+				});
+
+			document.getElementById('http_auth_enabled').addEventListener('change', (e) => {
+				this.form.querySelectorAll('[name^=http_]').forEach(field => {
+					if (!field.isSameNode(e.target)) {
+						field.disabled = !e.target.checked;
+					}
+				});
+			});
+
+			document.getElementById('saml_auth_enabled').addEventListener('change', (e) => {
+				this.form.querySelectorAll('[name^=saml_]').forEach(field => {
+					if (!field.isSameNode(e.target)) {
+						field.disabled = !e.target.checked;
+					}
+				});
+			});
+
+			this.form.addEventListener('submit', (e) => {
+				if (!this._authFormSubmit()) {
+					e.preventDefault();
+				}
+			});
+		}
+
+		_authFormSubmit() {
+			const fields_to_trim = ['#saml_idp_entityid', '#saml_sso_url', '#saml_slo_url', '#saml_username_attribute',
 				'#saml_sp_entityid', '#saml_nameid_format'
-			]);
+			];
+			document.querySelectorAll(fields_to_trim.join(', ')).forEach((elem) => {
+				elem.value = elem.value.trim();
+			});
 
-			return proceed;
-		});
+			const auth_type = document.querySelector('[name=authentication_type]:checked').value;
+			const warning_msg = <?= json_encode(
+				_('Switching authentication method will reset all except this session! Continue?')
+			) ?>;
 
-		$form.find('#http_auth_enabled, #ldap_configured, #saml_auth_enabled').on('change', function() {
-			var fields;
+			return (auth_type == this.db_authentication_type || confirm(warning_msg));
+		}
 
-			if ($(this).is('#http_auth_enabled')) {
-				fields = $form.find('[name^=http_]');
+		_addLdapServers(ldap_servers, ldap_default_row_index) {
+			for (const [row_index, ldap] of Object.entries(ldap_servers)) {
+				ldap.row_index = row_index;
+				ldap.is_default = (ldap.row_index == ldap_default_row_index) ? 'checked' : '';
+
+				document
+						.querySelector('#ldap-servers tbody')
+						.appendChild(this._prepareServerRow(ldap));
 			}
-			else if ($(this).is('#ldap_configured')) {
-				fields = $form.find('[name^=ldap_],button[name=change_bind_password]');
+		}
+
+		editLdapServer(row = null) {
+			let popup_params;
+
+			if (row !== null) {
+				const row_index = row.dataset.row_index;
+
+				popup_params = {
+					row_index,
+					add_ldap_server: 0,
+					name: row.querySelector(`[name="ldap_servers[${row_index}][name]"`).value,
+					host: row.querySelector(`[name="ldap_servers[${row_index}][host]"`).value,
+					port: row.querySelector(`[name="ldap_servers[${row_index}][port]"`).value,
+					base_dn: row.querySelector(`[name="ldap_servers[${row_index}][base_dn]"`).value,
+					search_attribute: row.querySelector(`[name="ldap_servers[${row_index}][search_attribute]"`).value,
+					search_filter: row.querySelector(`[name="ldap_servers[${row_index}][search_filter]"`).value,
+					start_tls: row.querySelector(`[name="ldap_servers[${row_index}][start_tls]"`).value,
+					bind_dn: row.querySelector(`[name="ldap_servers[${row_index}][bind_dn]"`).value,
+					description: row.querySelector(`[name="ldap_servers[${row_index}][description]"`).value
+				};
+
+				const userdirectoryid_input = row.querySelector(`[name="ldap_servers[${row_index}][userdirectoryid]"`);
+				const bind_password_input = row.querySelector(`[name="ldap_servers[${row_index}][bind_password]"`);
+
+				if (userdirectoryid_input !== null) {
+					popup_params['userdirectoryid'] = userdirectoryid_input.value;
+				}
+
+				if (bind_password_input !== null) {
+					popup_params['bind_password'] = bind_password_input.value;
+				}
 			}
 			else {
-				fields = $form.find('[name^=saml_]');
+				let row_index = 0;
+
+				while (document.querySelector(`#ldap-servers [data-row_index="${row_index}"]`) !== null) {
+					row_index++;
+				}
+
+				popup_params = {
+					row_index,
+					add_ldap_server: 1
+				};
 			}
 
-			fields
-				.not('[name=http_auth_enabled], [name=ldap_configured], [name=saml_auth_enabled]')
-				.prop('disabled', !this.checked);
-		});
+			const overlay = PopUp('popup.ldap.edit', popup_params, {dialogueid: 'ldap_edit'});
+
+			overlay.$dialogue[0].addEventListener('dialogue.submit', (e) => {
+				const ldap = e.detail;
+
+				if (row === null) {
+					ldap.is_default = document.getElementById('ldap-servers')
+							.querySelector('input[name="ldap_default_row_index"]:checked') === null
+						? 'checked'
+						: '';
+					ldap.usrgrps = 0;
 
-		$form.find('button#change_bind_password').click(function() {
-			$form.find('[name=action]')
-				.val($form.find('[name=action_passw_change]').val());
+					document
+						.querySelector('#ldap-servers tbody')
+						.appendChild(this._prepareServerRow(ldap));
+				}
+				else {
+					ldap.is_default = row.querySelector('input[name="ldap_default_row_index"]').checked === true
+						? 'checked'
+						: '';
+					ldap.usrgrps = row.querySelector('.js-ldap-usergroups').textContent;
+
+					row.parentNode.insertBefore(this._prepareServerRow(ldap), row);
+					row.remove();
+				}
+			});
+		}
+
+		_prepareServerRow(ldap) {
+			const template_ldap_server_row = new Template(this._templateLdapServerRow());
+			const template = document.createElement('template');
+			template.innerHTML = template_ldap_server_row.evaluate(ldap).trim();
+			const row = template.content.firstChild;
+
+			const optional_fields = ['userdirectoryid', 'bind_password', 'start_tls', 'search_filter'];
+
+			for (const field of optional_fields) {
+				if (!(field in ldap)) {
+					row.querySelector('input[name="ldap_servers[' + ldap.row_index + '][' + field + ']"]').remove();
+				}
+			}
+
+			if (ldap.usrgrps > 0) {
+				row.querySelector('.js-remove').disabled = true;
+			}
 
-			submitFormWithParam('form_auth', 'change_bind_password', '1');
-		});
+			return row;
+		}
 
-		$form.find('[name=ldap_test]').click(function() {
-			warn = false;
-		});
-	});
+		_templateLdapServerRow() {
+			return `
+				<tr data-row_index="#{row_index}">
+					<td>
+						<a href="javascript:void(0);" class="wordwrap js-edit">#{name}</a>
+						<input type="hidden" name="ldap_servers[#{row_index}][userdirectoryid]" value="#{userdirectoryid}">
+						<input type="hidden" name="ldap_servers[#{row_index}][name]" value="#{name}">
+						<input type="hidden" name="ldap_servers[#{row_index}][host]" value="#{host}">
+						<input type="hidden" name="ldap_servers[#{row_index}][port]" value="#{port}">
+						<input type="hidden" name="ldap_servers[#{row_index}][base_dn]" value="#{base_dn}">
+						<input type="hidden" name="ldap_servers[#{row_index}][search_attribute]" value="#{search_attribute}">
+						<input type="hidden" name="ldap_servers[#{row_index}][search_filter]" value="#{search_filter}">
+						<input type="hidden" name="ldap_servers[#{row_index}][start_tls]" value="#{start_tls}">
+						<input type="hidden" name="ldap_servers[#{row_index}][bind_dn]" value="#{bind_dn}">
+						<input type="hidden" name="ldap_servers[#{row_index}][bind_password]" value="#{bind_password}">
+						<input type="hidden" name="ldap_servers[#{row_index}][description]" value="#{description}">
+					</td>
+					<td class="wordbreak">#{host}</td>
+					<td class="js-ldap-usergroups">#{usrgrps}</td>
+					<td>
+						<input type="radio" name="ldap_default_row_index" value="#{row_index}" #{is_default}>
+					</td>
+					<td>
+						<button type="button" class="<?= ZBX_STYLE_BTN_LINK ?> js-remove"><?= _('Remove') ?></button>
+					</td>
+				</tr>
+			`;
+		}
+	};
 </script>
diff --git a/ui/app/views/js/administration.usergroup.edit.js.php b/ui/app/views/js/administration.usergroup.edit.js.php
index 0cfade23d00..009ad408762 100644
--- a/ui/app/views/js/administration.usergroup.edit.js.php
+++ b/ui/app/views/js/administration.usergroup.edit.js.php
@@ -34,15 +34,34 @@
 			$tag_filter_table_container  = $form.find('table#tag-filter-table').parent(),
 			$ms_tag_filter_groups        = $new_tag_filter_table.find('.multiselect'),
 			$ms_group_right_groups       = $new_group_right_table.find('.multiselect'),
+			$userdirectory               = $form.find('[name="userdirectoryid"]'),
+			$gui_access                  = $form.find('[name="gui_access"]'),
 			timeoutid_new_group_right,
 			timeoutid_new_tag_filter,
 			xhr_new_group_right,
 			xhr_new_tag_filter;
 
+		$gui_access.on('change', onFrontendAccessChange);
+		onFrontendAccessChange.apply($gui_access);
+
 		$form.submit(function() {
 			$form.trimValues(['#name']);
 		});
 
+		/**
+		 * Handle "Frontend access" selector change.
+		 */
+		function onFrontendAccessChange() {
+			let gui_access = $(this).val();
+
+			if (gui_access == <?= GROUP_GUI_ACCESS_INTERNAL ?> || gui_access == <?= GROUP_GUI_ACCESS_DISABLED ?>) {
+				$userdirectory.attr('disabled', 'disabled');
+			}
+			else {
+				$userdirectory.removeAttr('disabled');
+			}
+		}
+
 		/**
 		 * Collects data.
 		 *
diff --git a/ui/app/views/js/popup.ldap.edit.js.php b/ui/app/views/js/popup.ldap.edit.js.php
new file mode 100644
index 00000000000..37a79406725
--- /dev/null
+++ b/ui/app/views/js/popup.ldap.edit.js.php
@@ -0,0 +1,166 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+?>
+
+window.ldap_edit_popup = new class {
+
+	constructor() {
+		this.overlay = null;
+		this.dialogue = null;
+		this.form = null;
+		this.advanced_chbox = null;
+	}
+
+	init() {
+		this.overlay = overlays_stack.getById('ldap_edit');
+		this.dialogue = this.overlay.$dialogue[0];
+		this.form = this.overlay.$dialogue.$body[0].querySelector('form');
+		this.advanced_chbox = document.getElementById('advanced_configuration');
+
+		this.advanced_chbox.addEventListener('change', (e) => {
+			this.toggleAdvancedConfiguration(e.target.checked);
+		});
+
+		this.toggleAdvancedConfiguration(this.advanced_chbox.checked);
+
+		if (document.getElementById('bind-password-btn') !== null) {
+			document.getElementById('bind-password-btn').addEventListener('click', this.showPasswordField);
+		}
+	}
+
+	toggleAdvancedConfiguration(checked) {
+		for (const element of this.form.querySelectorAll('.advanced-configuration')) {
+			element.classList.toggle('<?= ZBX_STYLE_DISPLAY_NONE ?>', !checked);
+		}
+	}
+
+	showPasswordField(e) {
+		const form_field = e.target.parentNode;
+		const password_field = form_field.querySelector('[name="bind_password"][type="password"]');
+		const password_var = form_field.querySelector('[name="bind_password"][type="hidden"]');
+
+		password_field.style.display = '';
+		password_field.disabled = false;
+
+		if (password_var !== null) {
+			form_field.removeChild(password_var);
+		}
+		form_field.removeChild(e.target);
+	}
+
+	openTestPopup() {
+		const fields = this.preprocessFormFields(getFormFields(this.form));
+
+		const popup_params = {
+			host: fields.host,
+			port: fields.port,
+			base_dn: fields.base_dn,
+			bind_dn: fields.bind_dn,
+			search_attribute: fields.search_attribute
+		};
+
+		const optional_fields = ['userdirectoryid', 'bind_password', 'start_tls', 'search_filter'];
+
+		for (const field of optional_fields) {
+			if (fields[field] !== undefined) {
+				popup_params[field] = fields[field];
+			}
+		}
+
+		const test_overlay = PopUp('popup.ldap.test.edit', popup_params, {dialogueid: 'ldap_test_edit'});
+		test_overlay.xhr.then(() => this.overlay.unsetLoading());
+	}
+
+	submit() {
+		this.removePopupMessages();
+		this.overlay.setLoading();
+
+		const fields = this.preprocessFormFields(getFormFields(this.form));
+		const curl = new Curl(this.form.getAttribute('action'), false);
+
+		fetch(curl.getUrl(), {
+			method: 'POST',
+			headers: {'Content-Type': 'application/json'},
+			body: JSON.stringify(fields)
+		})
+			.then((response) => response.json())
+			.then((response) => {
+				if ('error' in response) {
+					throw {error: response.error};
+				}
+
+				overlayDialogueDestroy(this.overlay.dialogueid);
+
+				this.dialogue.dispatchEvent(new CustomEvent('dialogue.submit', {detail: response.body}));
+			})
+			.catch((exception) => {
+				let title;
+				let messages = [];
+
+				if (typeof exception === 'object' && 'error' in exception) {
+					title = exception.error.title;
+					messages = exception.error.messages;
+				}
+				else {
+					title = <?= json_encode(_('Unexpected server error.')) ?>;
+				}
+
+				const message_box = makeMessageBox('bad', messages, title, true, true)[0];
+
+				this.form.parentNode.insertBefore(message_box, this.form);
+			})
+			.finally(() => {
+				this.overlay.unsetLoading();
+			});
+	}
+
+	removePopupMessages() {
+		for (const el of this.form.parentNode.children) {
+			if (el.matches('.msg-good, .msg-bad, .msg-warning')) {
+				el.parentNode.removeChild(el);
+			}
+		}
+	}
+
+	preprocessFormFields(fields) {
+		this.trimFields(fields);
+
+		if (fields.advanced_configuration != 1) {
+			delete fields.start_tls;
+			delete fields.search_filter;
+		}
+
+		delete fields.advanced_configuration;
+
+		return fields;
+	}
+
+	trimFields(fields) {
+		const fields_to_trim = ['name', 'host', 'base_dn', 'bind_dn', 'search_attribute', 'search_filter',
+			'description'];
+		for (const field of fields_to_trim) {
+			if (field in fields) {
+				fields[field] = fields[field].trim();
+			}
+		}
+	}
+}();
diff --git a/ui/app/views/js/popup.ldap.test.edit.js.php b/ui/app/views/js/popup.ldap.test.edit.js.php
new file mode 100644
index 00000000000..85775213789
--- /dev/null
+++ b/ui/app/views/js/popup.ldap.test.edit.js.php
@@ -0,0 +1,98 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+/**
+ * @var CView $this
+ */
+?>
+
+window.ldap_test_edit_popup = new class {
+
+	constructor() {
+		this.overlay = null;
+		this.dialogue = null;
+		this.form = null;
+	}
+
+	init() {
+		this.overlay = overlays_stack.getById('ldap_test_edit');
+		this.dialogue = this.overlay.$dialogue[0];
+		this.form = this.overlay.$dialogue.$body[0].querySelector('form');
+	}
+
+	submit() {
+		this.removePopupMessages();
+		this.overlay.setLoading();
+
+		const fields = this.trimFields(getFormFields(this.form));
+		const curl = new Curl(this.form.getAttribute('action'), false);
+
+		fetch(curl.getUrl(), {
+			method: 'POST',
+			headers: {'Content-Type': 'application/json'},
+			body: JSON.stringify(fields)
+		})
+			.then((response) => response.json())
+			.then((response) => {
+				if ('error' in response) {
+					throw {error: response.error};
+				}
+				else if ('success' in response) {
+					const message_box = makeMessageBox('good', [], response.success.title, false, true)[0];
+
+					this.form.parentNode.insertBefore(message_box, this.form);
+				}
+			})
+			.catch((exception) => {
+				let title;
+				let messages = [];
+
+				if (typeof exception === 'object' && 'error' in exception) {
+					title = exception.error.title;
+					messages = exception.error.messages;
+				}
+				else {
+					title = <?= json_encode(_('Unexpected server error.')) ?>;
+				}
+
+				const message_box = makeMessageBox('bad', messages, title, true, true)[0];
+
+				this.form.parentNode.insertBefore(message_box, this.form);
+			})
+			.finally(() => {
+				this.overlay.unsetLoading();
+			});
+	}
+
+	removePopupMessages() {
+		for (const el of this.form.parentNode.children) {
+			if (el.matches('.msg-good, .msg-bad, .msg-warning')) {
+				el.parentNode.removeChild(el);
+			}
+		}
+	}
+
+	trimFields(fields) {
+		fields.test_username = fields.test_username.trim();
+
+		return fields;
+	}
+};
